openerp.partner_print_voucher = function (instance, local) {
    local.widgetInstance = null;
    local.parentInstance = null;

    local.PrintVoucherWidget = instance.Widget.extend({
        template : "partner_print_voucher.PrintVoucher",
        resVoucher:[],
        resPartner:[],
        resCompany:[],
        resCurrency:[],
        jsonDoc:[],
        // Init
        init:function(parent){
            this._super(parent);
        },
        updateId : function(id){
            var self = this;
            self.id=id;
        },
        start: function () {
            var self = this;
            this.$el.click(function (e) {
                self.fecthInitial();
            });
        },
        fecthInitial: function(){
            var id= openerp.webclient._current_state.id;
            var self = this;
            self.fecthVoucher(id).then(function(voucher){
                return voucher;
            }).then(function(voucher){
                self.resVoucher = voucher;
                return self.fetchPartner();
            }).then(function(partner){
                self.resPartner = partner;
                return self.fetchCompany();
            }).then(function(company){
                self.resCompany = company;
                return self.fetchCurrency();
            }).then(function(currency){
                self.resCurrency = currency;
                return self.drawJSON();
            }).then(function(jsondoc){
                self.jsonDoc= jsondoc
                return self.drawPDF();
            });
            return false;
        },
        // Consultar Pagos
        fecthVoucher: function(id){
            var defer = $.Deferred();
            var fields=['id','number','journal_id','partner_id','amount','date','reference','company_id','currency_id'];
            var domain=[['id','=', id]];
            var Voucher = new instance.web.Model('account.voucher');
            Voucher.query(fields).filter(domain).order_by('id').all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        // Consultar Clientes
        fetchPartner: function () {
            var self = this;
            var defer = $.Deferred();
            var partner_id = _.flatten(_.map(self.resVoucher,function(map){
                return map.partner_id[0];
            }));
            var fields=['id','name','street','street2','state_id', 'country_id'];
            var domain=[['id','=', partner_id]];
            var Partner = new instance.web.Model('res.partner');
            Partner.query(fields).filter(domain).order_by('id').all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        // Consultar Clientes
        fetchCompany: function () {
            var self = this;
            var defer = $.Deferred();
            var company_id = _.flatten(_.map(self.resVoucher,function(map){
                return map.company_id[0];
            }));
            var fields=['id','name','street','street2','state_id', 'country_id'];
            var domain=[['id','=', company_id]];
            var Company = new instance.web.Model('res.company');
            Company.query(fields).filter(domain).order_by('id').all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        // Consultar Clientes
        fetchCurrency: function () {
            var self = this;
            var defer = $.Deferred();
            var currency_id = _.flatten(_.map(self.resVoucher,function(map){
                return map.currency_id[0];
            }));
            var fields=['id','name','symbol'];
            var domain=[['id','=', currency_id]];
            var Currency = new instance.web.Model('res.currency');
            Currency.query(fields).filter(domain).order_by('id').all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        valorNull:function(dato){
            var valor ="";
            if (dato){
                if(dato == true && typeof dato == 'boolean'){
                    valor=" ";
                }else{
                    valor=dato;
                }
            }
            return valor;
        },
        // Obtener Datos del JSON
        drawJSON:function(){
            var defer = $.Deferred();
            $.getJSON('./partner_print_voucher/static/src/json/print_voucher.json').then(function(doc){
                defer.resolve(doc);
            });
            return defer;
        },
        getPartner: function(partner_id){
            var self = this;
            return _.filter(self.resPartner,function(item){
                return item.id === partner_id;
            }).shift();
        },
        getCompany: function(company_id){
            var self = this;
            return _.filter(self.resCompany,function(item){
                return item.id === company_id;
            }).shift();
        },
        getCurrency: function(currency_id){
            var self = this;
            return _.filter(self.resCurrency,function(item){
                return item.id === currency_id;
            }).shift();
        },
        // Generar el PDF
        drawPDF:function(){
            var self = this;
            var doc=[];
            var currency_name;
            var pdfDoc = new jsPDF();
            var resVoucher = self.resVoucher;
            var partner = self.getPartner(resVoucher[0].partner_id[0]);
            var company = self.getCompany(resVoucher[0].company_id[0]);
            var currency = self.getCurrency(resVoucher[0].currency_id[0]);
            if(currency.name = "PYG"){
                currency_name = "Guaranies"
            }else{
                currency_name = "Dolares"
            }
            doc.push({
                number : resVoucher[0].number,
                date : moment(resVoucher[0].date).format("DD/MM/YYYY"),
                reference : resVoucher[0].reference,
                amount : accounting.formatNumber(resVoucher[0].amount,0,".",""),
                journal_id : resVoucher[0].journal_id[1],
                partner_id : partner.name,
                company_id : resVoucher[0].company_id[1],
                customer_address : self.valorNull(partner.state_id[1])+", "+self.valorNull(partner.country_id[1]),
                company_address : self.valorNull(company.state_id[1])+", "+self.valorNull(company.country_id[1]),
                currency_name : currency_name
            });
            console.log(doc);
            if(doc){
                var item;
                for (var i = 0; i < doc.length; i++) {
                    item=doc[i];
                    _.each(self.jsonDoc,function(jsondoc){
                        var texto =_.template(jsondoc.content)(item);
                        pdfDoc.setFontSize(jsondoc.size);
                        pdfDoc.setFontStyle(jsondoc.fontStyle);
                        pdfDoc.text(jsondoc.x,jsondoc.y, pdfDoc.splitTextToSize(texto,180),null,null,jsondoc.position);
                    })
                }
                pdfDoc.save('RECIBO_DINERO.pdf');
            };
        },
    });
    if (instance.web && instance.web.FormView) {
        instance.web.FormView.include({
            load_form: function (record) {
                this._super.apply(this, arguments);
                if (this.model !== 'account.voucher') return;
                local.parentInstance = this;
                if (local.widgetInstance) {
                    local.widgetInstance.updateId(record.id);
                }
                local.widgetInstance = new local.PrintVoucherWidget(this);
                var elemento = this.$el.find('.oe_form_sheet.oe_form_sheet_width');
                elemento =  elemento.find('.oe_right.oe_button_box.voucher_button_box');
                local.widgetInstance.appendTo(elemento);
                local.widgetInstance.updateId(record.id);
            }
        });
    }
}
